#include "Windows/SectionLock.h"

SectionLock::SectionLock() noexcept {
    InitializeCriticalSection(&section_);
}

SectionLock::~SectionLock() {
    DeleteCriticalSection(&section_);
}

void SectionLock::Lock() {
    EnterCriticalSection(&section_);
}

bool SectionLock::TryLock() {
    bool success = TryEnterCriticalSection(&section_);
    return success;
}

void SectionLock::UnLock() {
    LeaveCriticalSection(&section_);
}
